<?php

$form = array();

$form['username'] = $username = trim($_POST['username']);
$form['password'] = $password = trim($_POST['password']);
$form['password2'] = $password2 = trim($_POST['password2']);
$form['name'] = $name = trim($_POST["name"]);
$form['email'] = $email = trim($_POST["email"]);

$_SESSION['form'] = serialize($form);

if(!$username){
    $_SESSION['error'] = "Choose a username.";
    Header("Location: get.php?q=signup");
    exit;    
}

if(!$password){
    $_SESSION['error'] = "Choose a password.";
    Header("Location: get.php?q=signup");
    exit;    
}

if($password != $password2){
    $_SESSION['error'] = "Passwords don't match.";
    Header("Location: get.php?q=signup");
    exit;    
}

if(!$name){
    $_SESSION['error'] = "What is your name?";
    Header("Location: get.php?q=signup");
    exit;    
}

if(!$email){
    $_SESSION['error'] = "E-Mail is required for singup.";
    Header("Location: get.php?q=signup");
    exit;    
}

$userid = createUser(new User(array(   
    "name"=>$name,
    "username"=>$username,
    "password"=>$password,
    "email"=>$email
)));

if(db_duplicate()){
    $_SESSION['error'] = "Someone's already using this username ($username). Choose another.";
    Header("Location: get.php?q=signup");
    exit;    
}

// add user to role 1 by default
addUserToRole($userid,1);

Header("Location: get.php?q=login");
?>
