<?php

class User {
    var $id;
    var $username;
    var $password;
    var $name;
    var $email;
    var $usersince;
    var $lastlogin;

    function User($arr){
         $this->id = $arr['id'];
         $this->username = $arr['username'];
         $this->password = $arr['password'];
         $this->name = $arr['name'];
         $this->email = $arr['email'];
         $this->usersince = $arr['usersince'];
         $this->lastlogin = $arr['lastlogin'];
    }
}

// given a user id, retrieves the user object.
function getUser($id){
    $q = "select * from userinfo where id=$id";
    $ret = NULL;
    $res = db_query($q);
    if($line = db_fetch($res)){
        $ret = new User($line);
    }
    db_freeres($res);
    return $ret;
}

// given a user id, retrieves the user object.
function getUserLogin($username,$password){
    $q = "select * from userinfo where ".
         "username='$username' and ".
         "password='$password'";
    $ret = NULL;
    $res = db_query($q);
    if($line = db_fetch($res)){
        $ret = new User($line);
    }
    db_freeres($res);
    return $ret;
}

//given a userid, and a permission
//returns 1 if user has permission, or 0 otherwise
function userHasPermission($userid,$permission){
    // merges all tables dealing with security
    // returns a record if there is a link
    // between user and a certain permission.
    $q= "select u.id ".
        "from userinfo u,userrole ur,role r, ".
        "rolepermission rp, permission p ".
        "where u.id = ur.userid AND ".
        "ur.roleid = r.id AND ".
        "r.id = rp.roleid AND ".
        "rp.permissionid = p.id AND ".
        "u.id = $userid AND ".
        "p.name='$permission'";
    $ret = 0;
    $res = db_query($q);
    if($line = db_fetch($res)){
        $ret = 1;
    }
    db_freeres($res);
    return $ret;
}

// update user info
function updateUser($user){
    $q = "update userinfo set ".
         "username='".$user->username."', ".
         "password='".$user->password."', ".
         "name='".$user->name."', ".
         "email='".$user->email."' ".
         "where id=".$user->id;
    db_query($q);
}

// create user info
function createUser($user){
    $q = "insert into userinfo ".
         "(username,password,name,email,".
         "usersince,lastlogin) values ( ".
         "'".$user->username."',".
         "'".$user->password."',".
         "'".$user->name."',".
         "'".$user->email."',".
         "NOW(),".
         "NOW())";
    db_query($q);
    return db_insertid();
}

// update the last login time
function userloginupdate($userid){
    $q = "update userinfo set ".
         "lastlogin = NOW() ".
         "where id=".$userid;
    db_query($q);
}

// add user to role 
// (create a link between user and role)
function addUserToRole($userid,$roleid){
    $q = "insert into userrole ".
         " (userid,roleid) values ".
         "(".$userid.",".$roleid.")";         
    db_query($q);    
}

?>